<?php

namespace App\Http\Controllers\api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Response;
use App\Http\Utility\Common;
use App\Http\Service\DataService;
use App\Http\Utility\Defaults;
use Illuminate\Support\Str;
use Validator;
use App\Users;
use App\Usertoken;
use DB;

class ApiController extends Controller
{
	public function registration(Request $request)
	{
		#echo "hello";die;"device_type"deviceToken
		$response   = new Response();
    	$rules      = [
    		'username' => 'required|min:2|regex:/^[\pL\s\-]+$/u',
            'email'=> 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:users',
            'telephone'=> 'required|numeric|digits_between:9,15|unique:users',
            'password'    => 'required|min:4'
          ];

    	$validator  = Validator::make($request->all(), $rules);

    	if ($validator->fails()) { 
    		#print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
    	} else {
    			$data   = new DataService();
        	try{
        		 #echo "hello";die;
            $username = $request->username;
            $email    = $request->email;
            $telephone    = $request->telephone;
            $device_type    = $request->device_type;
            $deviceToken    = $request->deviceToken;
            $password =md5($request->password);
            
            $insert_data = array(
    		    	"username" => $username,
    	           "email" => $email,
                   "telephone" => $telephone,
                   "device_type" => $device_type,
                   "deviceToken" => $deviceToken,
    	    		"password" => $password
		    	);
            #print_r($insert_data);die;
            #DB::enableQueryLog();
            $user_obj = new Users($insert_data);
		    	$user_obj->save();
                $gett = DB::getQueryLog();
                #print_r($gett);die;
               # echo "hello";die;
			    	$user_id = $user_obj->id;
	         //$status = $textMessage->sendMessage($messageData);
	     	   /**********************/

		         /* Send welcome mail at registered mail id*/
		         /*$objDemo = new \stdClass();
		         $objDemo->sender = 'SwissExpress';
		         $objDemo->invoice_file = '';
		         $objDemo->receiver = $firstname;
		         $objDemo->from = env( 'MAIL_USERNAME' );
		         $objDemo->subject = trans('messages.Welcome to SwissExpress');
		         $objDemo->message = trans('messages.Welcome to SwissExpress. Thank you to connect with us');
		         $objDemo->view_file = 'emailtemplate.welcome_mail';
		         Mail::to($email)->send(new DemoEmail($objDemo)); */
	          /**************/

	        	$data  = new DataService();
	        	if (!empty($user_id))
	        	{
                   $record = $user_obj->select("*")->where("id",$user_id)->get()->toArray();
	        		$data->error         = Common::error_false;
	            $data->errorMessage  = trans('messages.sucess');
                $data->record  = $record;
	         }else{
	        		$data->error        = Common::error_true;
	            $data->errorMessage = trans('messages.query');
	        	}
	        	$response = $data;
	    		
	    			//print_r($response);die;
        	}catch(\Illuminate\Database\QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        	}
        	DB::commit();
        	
    	}
    	$responsedata = Defaults::encode($response);
    	return $responsedata;
	}
    
	public function login(Request $request)
    {
       	$response = new Response();
        $rules   = ['email'   => 'required|email',
                    'password' =>'required'];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
        } else {
            $email = $request->email;
            $password = md5($request->password);
            
            

            $user_obj = new Users();
    		$isExist = $user_obj->select("*")->where("email",$email)->where("password",$password)->first();
            
            #echo "<pre>";print_r($isExist);die;

            /*print_r($isExist);
            echo "break";
            print_r($x);
            die;*/
            $data   = new DataService();
            if($isExist)
            {
                /*echo $isExist["status"];
                print_r($isExist);die;*/
                if($isExist["mobile_verify"] == 0)
                {
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.mobile_not_verified');
                }else{
                    if($isExist["status"] == 0)
                    {
                        $data->error         = Common::error_true;
                        $data->errorMessage  = trans('messages.account_hold');
                    }else if($isExist["status"] == 2)
                    {
                        $data->error         = Common::error_true;
                        $data->errorMessage  = trans('messages.account_unaproved');                     
                    }else if($isExist["status"] == 1)
                    {

                        $array_new_data = array(
                            $device_type => $request->device_type,
                            $deviceToken => $request->deviceToken
                        );
                        $user_obj = new Users();
                        $user_obj->where("id",$isExist["id"])->update($array_new_data);
                            $drivertoken_obj = new Usertoken();
                        $token = Str::random(60).$isExist["email"].$isExist["password"].$isExist["id"];
                        $hash_token = hash('sha256', $token);
                        $token_record = $drivertoken_obj->select("id")->where('user_id',$isExist["id"])->first();
                        $array_user = array(
                                "user_id" => $isExist["id"],
                                "token" => $hash_token
                        );
                        #print_r($token_record);die;
                        if($token_record)
                        {
                            //echo "ifff";
                            $drivertoken_obj = new Usertoken();
                            $response = $drivertoken_obj->where("id",$token_record["id"])->update($array_user);
                        }else{
                            //echo "elseee";
                            $drivertoken_obj = new Usertoken($array_user);
                            $response = $drivertoken_obj->save();
                        }
                        //die;
                        $data->error = Common::error_false;
                        $data->errorMessage = trans('messages.isLogin');
                        #$data->usersDetails  = drivers::select('*')->where('id',$isExist['id'])->first();
                        $data->record  = $isExist;
                        $data->token  = $hash_token;
                    }else{
                        $data->error         = Common::error_true;
                        $data->errorMessage  = trans('messages.query');
                    }
                }            
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.login');
            }
            $response = $data;
        }
            $responsedata = Defaults::encode($response);
            return $responsedata;
    }
	public function getProfile(request $request)
    {
        $response = new Response();
        if(!$request->token_check){
            $response->error        = Common::error_true;
            $response->errorMessage = trans('messages.token_mismatch');
        }else{
            $messages = ['user_id.required' => trans('validation.required'),
                  'user_id.numeric' => trans('validation.numeric')];

            $rules   = ['user_id'   => 'required|numeric'];
            $validator  = Validator::make($request->all(), $rules,$messages);
            if ($validator->fails()) {
             $data                   = $validator->messages();
             $response->error        = Common::error_true;
             $response->errorMessage = $data->first();
            } else {
                $userId = $request->user_id;
                $isExist = Users::select('*')->where('id',$userId)->first();
                $data   = new DataService();
                if($isExist)
                {
                    $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
                    $isExist["old_image"] = $isExist["image"];
                    $data->error = Common::error_false;
                    $data->errorMessage = trans('messages.sucess');
                    $data->usersDetails  = $isExist;
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.invalidUser');
                }
                $response = $data;
            }
        }
        $responsedata = Defaults::encode($response);
        return $responsedata;
    }
    public function EditUserProfile(Request $request)
    {
        $response = new Response();
        if(!$request->token_check){
            $response->error        = Common::error_true;
            $response->errorMessage = trans('messages.token_mismatch');
        }else{
            $user_id = $request->user_id;
            
            $messages = ['user_id.required' => trans('validation.required'),
                  'user_id.numeric' => trans('validation.numeric'),
                  'firstname.required' =>trans('validation.required'),
                  'email.required'    =>trans('validation.required'),
                  'email.email'       =>trans('validation.email'),
                  'email.unique'       =>trans('validation.unique'),
                  ];
            $rules   = [
                'user_id'   => 'required|numeric',
                'username'=>'required|min:2|regex:/^[\pL\s\-]+$/u',
                'email'   => 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:users,email,'.$user_id,
                'address'   => 'required|regex:/^[\w]+([-_\s]{1}[a-z0-9]+)*$/i',
                'telephone'=> 'required|numeric|digits_between:9,15|unique:users,telephone,'.$user_id,
                "image" => "mimes:jpeg,jpg,png,gif"
            ];
            $validator  = Validator::make($request->all(), $rules,$messages);
            if ($validator->fails()) {
             $data                   = $validator->messages();
             $response->error        = Common::error_true;
             $response->errorMessage = $data->first();
            } else {
                $data   = new DataService();
                try{

                    if(!empty($_FILES["image"]["name"]))
                    {
                        #echo "hello";die;
                        $image = $request->file('image');
                        //echo "<pre>";print_r($image);
                        $random = substr(md5(mt_rand()), 0, 4);
                        $file_name = $input['imagename'] = time().$random.'user'.'.'.$image->getClientOriginalExtension();
                        $destinationPath = public_path('/upload/usersprofile');
                        $image->move($destinationPath, $input['imagename']);
                        //echo $input['imagename']."form submit";

                        if(!empty($request->old_image))
                        {
                            $old_image = $request->old_image;
                            $destinationPath = public_path('/upload/usersprofile');
                            $file_pointer = $destinationPath.'/'.$old_image;
                            if (file_exists($file_pointer))
                            {
                                unlink($destinationPath.'/'.$old_image);
                            }

                        }
                    }else{
                        if(!empty($request->old_image))
                        {
                            $file_name = $request->old_image;
                        }else{
                            $file_name = "";
                        }
                    }

                    $user_id = $request->user_id;
                        $array_data = array(
                                "username" => $request->username,
                                "email" => $request->email,
                                "address" => $request->address,
                                "latitude" => $request->latitude,
                                "longitude" => $request->longitude,
                                "telephone" => $request->telephone,
                                "image" => $file_name,
                        );
                        #print_r($array_data);die;
                        $Users_obj = new Users();
                        $query_response = $Users_obj->where("id",$request->user_id)->update($array_data);

                        if($query_response == 1)
                        {
                            $isExist = Users::select('*')->where('id',$request->user_id)->first();
                            $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
                            $isExist["old_image"] = $isExist["image"];
                            

                            $data->error = Common::error_false;
                            $data->errorMessage = trans('messages.sucess');
                            $data->usersDetails = $isExist;
                        }else{
                            $data->error         = Common::error_true;
                            $data->errorMessage  = trans('messages.query');
                        }
                    }catch(QueryException $ex){
                    $jsonresp=$ex->getMessage();
                    DB::rollBack();
                    $data->error   = false;
                }
                
                $response = $data;
            }
        }
        $responsedata = Defaults::encode($response);
        return $responsedata;
    }
    public function userForgotPassword(Request $request)
    {
        $Users_obj = new Users;
        $response   = new Response();

        $rules = [
                'email' => 'required|email'
          ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()){ 
            #print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
        }else{
                $data   = new DataService();
            try{
                $email = $request->email;
                $record = $Users_obj->select("id","username","email")->where("email",$email)->get()->toArray();
                    if(count($record)>0)
                    {
                        $new_password = mt_rand(100000, 999999);
                        $new_password_md = md5($new_password);
                        $Users_obj->where("email",$email)->update(["password"=>$new_password_md]);

                        /* Send password on mail at registered mail id*/
                       /*$objDemo = new \stdClass();
                       $objDemo->sender = 'DoctUrgences';
                       $objDemo->invoice_file = '';
                       $objDemo->receiver = $record[0]["firstname"];
                       $objDemo->password = $new_password;
                       $objDemo->from = env( 'MAIL_USERNAME' );
                       $objDemo->subject = trans('messages.Welcome to DoctUrgences');
                       $objDemo->message = "translated message here";
                       $objDemo->view_file = 'emailtemplate.user_forget_password';
                       Mail::to($request->email)->send(new DemoEmail($objDemo)); */
                        /**************/
            
                        $data->error         = Common::error_false;
                        $data->errorMessage  = trans('messages.sucess');
                        #$data->record         = $record[0];
                    }else{
                        $data->error        = Common::error_true;
                    $data->errorMessage = trans('messages.no_record');
                    }
                }catch(QueryException $ex){
                  $jsonresp=$ex->getMessage();
                  DB::rollBack();
                  $data->error   = $jsonresp;
                }
                $response = $data;
            }
        DB::commit();
        $responsedata = Defaults::encode($response);
      return $responsedata;
    }
    
    
}
