<?php

namespace App\Http\Controllers\api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Response;
use App\Http\Utility\Common;
use App\Http\Service\DataService;
use App\Http\Utility\Defaults;
use Illuminate\Support\Str;
use Illuminate\Database\QueryException;
use Validator;
use App\Users;
use App\Usertoken;
use App\Hospitaluser;
use App\Hospitalcategory;
use App\Subcategory;
use App\Category;
use App\Hospitaloken;
use App\Settings;
use App\Appointments;
use App\Appointmentchat;
use App\Specialist;
use App\Admincontacts;
use App\Faqs;
use DB;

class HospitalController extends Controller
{
    //
	public function __construct()
	{
		DB::enableQueryLog();
	}
	public function getMainCategory(Request $request)
	{
		$Category_obj = new Category;
		$response   = new Response();
		$data   = new DataService();
  	try{
  		$record = $Category_obj->get()->toArray();
  		if(count($record)>0)
  		{
  			$data->error         = Common::error_false;
        $data->errorMessage  = trans('messages.sucess');
  			$data->record         = $record;
     	}else{
    		$data->error        = Common::error_true;
        $data->errorMessage = trans('messages.no_record');
    	}


  	}catch(\Illuminate\Database\QueryException $ex){
      $jsonresp=$ex->getMessage();
      DB::rollBack();
      $data->error   = $jsonresp;
  	}
  	DB::commit();
  	$response = $data;
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function getSubCategory(Request $request)
	{
		$Subcategory_obj = new Subcategory;
		$response   = new Response();
		$rules      = [
    				'category_id' => 'required'
          ];

    	$validator  = Validator::make($request->all(), $rules);

    	if ($validator->fails()) { 
    		#print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
    	}else{
					$data   = new DataService();
			  	try{
			  		$category_id  = $request->category_id;
					  		$record = $Subcategory_obj->where("cat_id",$category_id)->get()->toArray();
					  		if(count($record)>0){
					  			/*$array = array();
				  			$x=0;
				  			foreach ($record as $key => $value)
				  			{
				  				$array[$x]["id"] = $value["id"];
				  				$array[$x]["sub_cat_name"] = $value["sub_cat_name"];
				  				$x++;
				  			}*/
				  			$data->error         = Common::error_false;
				        $data->errorMessage  = trans('messages.sucess');
				  			$data->record         = $record;
					     	}else{
					    		$data->error        = Common::error_true;
					        $data->errorMessage = trans('messages.no_record');
				    	}
		  			}catch(\Illuminate\Database\QueryException $ex){
				      $jsonresp=$ex->getMessage();
				      DB::rollBack();
				      $data->error   = $jsonresp;
				  	}
  			$response = $data;
  		}
  	DB::commit();
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function hospitalRegistration(Request $request)
	{
		#echo "hello";die;
		$response   = new Response();
		if($request->category == 2)
		{
			$rules      = [
    				'fullname' => 'required|min:2',
    				'finess_number' => 'required|min:2',
    				'category' => 'required',
    				#'sub_cat.*' => 'required',
    				'admin_name' => 'required',
            'admin_email'=> 'required|email|unique:hospitalusers',
            'admin_telephone'=> 'required|max:15|min:7|unique:hospitalusers',
            'password'    => 'required|min:4',
            'address'    => 'required',
            'waiting_time'    => 'required|numeric',
          ];
		}else{

    	$rules      = [
    				'fullname' => 'required|min:2',
    				'finess_number' => 'required|min:2',
    				'category' => 'required',
    				"sub_cat"    => "required|array",
    				#'sub_cat.*' => 'required',
    				'admin_name' => 'required',
            'admin_email'=> 'required|email|unique:hospitalusers',
            'admin_telephone'=> 'required|max:15|min:7|unique:hospitalusers',
            'password'    => 'required|min:4',
            'address'    => 'required',
            'waiting_time'    => 'required|numeric',
          ];
		}

    	$validator  = Validator::make($request->all(), $rules);

    	if ($validator->fails()) { 
    		#print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
    	}else{
	    			$data   = new DataService();
	        	try{
	        		$latitude = $request->latitude;	
	        		$longitude = $request->longitude;
	        		if($latitude == '' || $longitude == '')
	        		{
	        			$data->error        = Common::error_true;
			          $data->errorMessage = trans('messages.google_address_error');
	        		}else{
	        			#print_r($request->all());
	        			$array_data = array(
	        					"fullname" => $request->fullname,
	        					"company_name" => $request->company_name,
	        					"finess_number" => $request->finess_number,
	        					"category" => $request->category,
	        					"admin_name" => $request->admin_name,
	        					"admin_email" => $request->admin_email,
	        					"admin_telephone" => $request->admin_telephone,
	        					"password" => md5($request->password),
	        					"address" => $request->address,
	        					"latitude" => $request->latitude,
	        					"longitude" => $request->longitude,
	        					"waiting_time" => $request->waiting_time,
	        					"status" => 1,
	        					"is_admin" => 0,
	        			);
	        			#echo "hello else";die;
	        			#DB::table('hospitalusers')->insert($array_data);die;
	        			$Hospitaluser_obj = new Hospitaluser();
	        			$last_id = $Hospitaluser_obj->insert_record($array_data);
	        			//$Hospitaluser_obj->save();
	        			#echo $last_id;
	        			/*$gett = DB::getQueryLog();
	        			print_r($gett);die;*/
	        			if (!empty($last_id))
			        	{
			        		$sub_cat = $request->sub_cat;
		        			for($x=0; $x<count($sub_cat); $x++)
		        			{
		        				$sub_cat_id = $sub_cat[$x]["id"];
			        			$array_data_second = array(
			        					"hospital_id" => $last_id,
			        					"sub_cat_id" => $sub_cat_id,
			        			);
			        			$Hospitalcategory_obj = new Hospitalcategory($array_data_second);
			        			$Hospitalcategory_obj->save();
		        			}
			        		$data->error         = Common::error_false;
			            $data->errorMessage  = trans('messages.sucess');
			         	}else{
			        		$data->error        = Common::error_true;
			            $data->errorMessage = trans('messages.query');
			        	}

	        		}
		        	
		    			//print_r($response);die;
	        	}catch(\Illuminate\Database\QueryException $ex){
	            $jsonresp=$ex->getMessage();
	            DB::rollBack();
	            $data->error   = $jsonresp;
	        	}
	        	DB::commit();
	        	$response = $data;
			}
			$responsedata = Defaults::encode($response);
	    return $responsedata;
	}
	public function hospitalLogin(Request $request)
	{
   	$response = new Response();
    $rules   = ['email'   => 'required|email',
                'password' =>'required'];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
        $data                   = $validator->messages();
        $response->error        = Common::error_true;
        $response->errorMessage = $data->first();
    } else {
        $email = $request->email;
        $password = md5($request->password);
        
        $Hospitaluser_obj = new Hospitaluser();
				$isExist = $Hospitaluser_obj->select("*")->where("admin_email",$email)->where("password",$password)->first();
        
        #echo "<pre>";print_r($isExist);die;

        /*print_r($isExist);
        echo "break";
        print_r($x);
        die;*/
        $data   = new DataService();
        if($isExist)
        {
            /*echo $isExist["status"];
            print_r($isExist);die;*/
            
            if($isExist["status"] == 0)
            {
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.account_hold');
            }else if($isExist["status"] == 2)
            {
            		$data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.account_unaproved');                    	
            }else if($isExist["status"] == 1)
            {
            		$drivertoken_obj = new Hospitaloken();
                $token = Str::random(60).$isExist["admin_email"].$isExist["password"].$isExist["id"];
                $hash_token = hash('sha256', $token);
                $token_record = $drivertoken_obj->select("id")->where('user_id',$isExist["id"])->first();
                $array_user = array(
                        "user_id" => $isExist["id"],
                        "token" => $hash_token
                );
                #print_r($token_record);die;
                if($token_record)
                {
                	//echo "ifff";
                    $drivertoken_obj = new Hospitaloken();
                    $response = $drivertoken_obj->where("id",$token_record["id"])->update($array_user);
                }else{
                	#echo "elseee";die;
                    $drivertoken_obj = new Hospitaloken($array_user);
                    $response = $drivertoken_obj->save();
                }
                //die;
                $data->error = Common::error_false;
                $data->errorMessage = trans('messages.isLogin');
                #$data->usersDetails  = drivers::select('*')->where('id',$isExist['id'])->first();
                $data->usersDetails  = $isExist;
                $data->token  = $hash_token;
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.query');
            }         
        }else{
            $data->error         = Common::error_true;
            $data->errorMessage  = trans('messages.login');
        }
        $response = $data;
    }
        $responsedata = Defaults::encode($response);
        return $responsedata;
	}
	public function getHospitalProfile(Request $request)
	{
		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();
		if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
    		$rules      = [
    				'hospital_id' => 'required'
          ];

	    	$validator  = Validator::make($request->all(), $rules);

	    	if ($validator->fails()) { 
	    		#print_r($validator->errors());die;
	            $data                   = $validator->messages();
	            $response->error        = Common::error_true;
	            $response->errorMessage = $data->first();
	    	}else{
					$data   = new DataService();
			  	try{
			  			$hospital_id = $request->hospital_id;
			  			$Hospitaluser_obj = new Hospitaluser();
			  			$record = $Hospitaluser_obj->select("hospitalusers.*","categories.cat_name")->join("categories","hospitalusers.category","categories.id")->where("hospitalusers.id",$hospital_id)->first();
			  			/*$gett = DB::getQueryLog();
			  			print_r($gett);*/
			  			#print_r($record);die;
			  		if($record){

			  			$id = $record["id"];
			  			$record["full_image"] = url('public/upload/usersprofile').'/'.$record["image"];
			  			$Hospitalcategory_obj = new Hospitalcategory();
			  			$sub_cat_record = $Hospitalcategory_obj->select("hospitalcategories.id","hospitalcategories.sub_cat_id","subcategories.sub_cat_name")->join("subcategories","hospitalcategories.sub_cat_id","subcategories.id")->where("hospitalcategories.hospital_id",$id)->get()->toArray();
			  			$data->error         = Common::error_false;
			        $data->errorMessage  = trans('messages.sucess');
			  			$data->record         = $record;
			  			$data->sub_cat_record         = $sub_cat_record;
			     	}else{
			    		$data->error        = Common::error_true;
			        $data->errorMessage = trans('messages.no_record');
			    	}
			  	}catch(\Illuminate\Database\QueryException $ex){
			      $jsonresp=$ex->getMessage();
			      DB::rollBack();
			      $data->error   = $jsonresp;
			  	}
			    $response = $data;	
	  	}
	  	DB::commit();
    }
		
  	
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function getAllSubCategory(Request $request)
	{
		$Subcategory_obj = new Subcategory;
		$response   = new Response();
		$data   = new DataService();
  	try{
  		$record = $Subcategory_obj->get()->toArray();
  		if(count($record)>0){
  			$array = array();
  			$x=0;
  			foreach ($record as $key => $value)
  			{
  				$array[$x]["id"] = $value["id"];
  				$array[$x]["sub_cat_name"] = $value["sub_cat_name"];
  				$x++;
  			}
  			$data->error         = Common::error_false;
        $data->errorMessage  = trans('messages.sucess');
  			$data->record         = $array;
     	}else{
    		$data->error        = Common::error_true;
        $data->errorMessage = trans('messages.no_record');
    	}


  	}catch(\Illuminate\Database\QueryException $ex){
      $jsonresp=$ex->getMessage();
      DB::rollBack();
      $data->error   = $jsonresp;
  	}
  	DB::commit();
  	$response = $data;
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function allHospital(Request $request)
	{
		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();
		$rules      = [
						'user_id' => 'required',
    				'current_lat' => 'required|min:2',
    				'current_long' => 'required|min:2'
          ];

    	$validator  = Validator::make($request->all(), $rules);

    	if ($validator->fails()) { 
    		#print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
    	}else{
				$data   = new DataService();
		  	try{
		  			$distance = 5;
		  			$current_lat = $request->current_lat;
		  			$current_long = $request->current_long;
		  			$category_id = $request->category_id;
		  			#$where = " WHERE category = '2' ";
		  			//"id","fullname","finess_number","company_name","category","admin_name","admin_email","admin_telephone","address","latitude","longitude","waiting_time"
		  			$where = "";
		  			if(!empty($category_id))
		  			{
		  				$where .= " WHERE hospitalcategories.sub_cat_id = '$category_id' OR hospitalusers.category = 2 ";

		  				$query = ("SELECT hospitalusers.id,hospitalusers.fullname,hospitalusers.finess_number,hospitalusers.company_name,hospitalusers.category,hospitalusers.admin_name,hospitalusers.admin_email,hospitalusers.admin_telephone,hospitalusers.address,hospitalusers.latitude,hospitalusers.longitude,hospitalusers.waiting_time, ( 6371 * acos ( cos ( radians('$current_lat') ) * cos( radians( latitude ) ) * cos( radians( longitude ) - radians('$current_long') ) + sin ( radians('$current_lat') ) * sin( radians( latitude ) ) ) ) AS distance FROM hospitalusers LEFT JOIN hospitalcategories ON hospitalusers.id=hospitalcategories.hospital_id $where GROUP BY hospitalusers.id HAVING CEILING(distance) <= $distance ");
		  			}else{
		  				
							$query = ("SELECT hospitalusers.id,hospitalusers.fullname,hospitalusers.finess_number,hospitalusers.company_name,hospitalusers.category,hospitalusers.admin_name,hospitalusers.admin_email,hospitalusers.admin_telephone,hospitalusers.address,hospitalusers.latitude,hospitalusers.longitude,hospitalusers.waiting_time, ( 6371 * acos ( cos ( radians('$current_lat') ) * cos( radians( latitude ) ) * cos( radians( longitude ) - radians('$current_long') ) + sin ( radians('$current_lat') ) * sin( radians( latitude ) ) ) ) AS distance FROM hospitalusers   GROUP BY hospitalusers.id HAVING CEILING(distance) <= $distance ");
		  				
		  			}
		  			$record = DB::select($query);

		  			#print_r($record);die;
		  			/*$gett = DB::getQueryLog();
		  			print_r($gett);die;*/
		  			$Specialist_obj = new Specialist();
		  			$specialist_array = array();
		  			$current_date = date("Y-m-d");
		  		if(count($record)>0)
		  		{
		  			$user_id = $request->user_id;
		  			$x=0;
		  			$final_array = array();
	  				foreach ($record as $key => $value)
	  				{
	  					$Appointments_obj = new Appointments;
	  					$appointment_record = $Appointments_obj->select("appointments.id as appointment_id","appointments.user_id","appointments.status")->where("user_id",$user_id)->where("hospital_id",$value->id)->where("request_date",$current_date)->orderBy("id","DESC")->get()->toArray();
	  					#$query_log = DB::getQueryLog();
	  					#echo "<pre>";print_r($query_log);
	  					#echo "<pre>";print_r($appointment_record);
	  					if(count($appointment_record)>0)
	  					{
	  						$record[$x]->status = $appointment_record[0]["status"];
	  					}else{
	  						$record[$x]->status = 5;
	  					}
	  					$x++;
	  				}
		  			#print_r($final_array);die;
		  			$data->error         = Common::error_false;
		        $data->errorMessage  = trans('messages.sucess');
		  			$data->record         = $record;
		     	}else{
		    		$data->error        = Common::error_true;
		        $data->errorMessage = trans('messages.no_record');
		    	}
		  	}catch(\Illuminate\Database\QueryException $ex){
		      $jsonresp=$ex->getMessage();
		      DB::rollBack();
		      $data->error   = $jsonresp;
		  	}
		    $response = $data;	
  	}
  	DB::commit();
  	
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function getHospitalDetail(Request $request)
	{
		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();
		$rules      = [
    				'hospital_id' => 'required',
    				'user_id' => 'required'
          ];

    	$validator  = Validator::make($request->all(), $rules);

    	if ($validator->fails()) { 
    		#print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
    	}else{
				$data   = new DataService();
		  	try{
		  			$hospital_id = $request->hospital_id;
		  			$Hospitaluser_obj = new Hospitaluser();
		  			$record = $Hospitaluser_obj->select("hospitalusers.id","fullname","finess_number","company_name","category","admin_name","admin_email","admin_telephone","address","latitude","longitude","waiting_time","categories.cat_name")->join("categories","hospitalusers.category","categories.id")->where("hospitalusers.id",$hospital_id)->first();
		  			/*$gett = DB::getQueryLog();
		  			print_r($gett);*/
		  			#print_r($record);die;

		  		if($record)
		  		{
		  			$record["current_time"] = date("H:i:s");
		  			$id = $record["id"];
		  			$Hospitalcategory_obj = new Hospitalcategory();
		  			$sub_cat_record = $Hospitalcategory_obj->select("hospitalcategories.id","hospitalcategories.sub_cat_id","subcategories.sub_cat_name")->join("subcategories","hospitalcategories.sub_cat_id","subcategories.id")->where("hospitalcategories.hospital_id",$id)->get()->toArray();
		  			#print_r($sub_cat_record);die;
		  			//user_id
		  			$user_id = $request->user_id;
		  			#$hospital_id
		  			#Appointments
		  			$date = date("Y-m-d");
		  			$Appointments_obj = new Appointments();
		  			$appointment_data = $Appointments_obj->select("appointments.*","hospitalusers.admin_telephone")->join("hospitalusers","hospitalusers.id","appointments.hospital_id")->where("appointments.hospital_id",$hospital_id)->where("appointments.user_id",$user_id)->where("appointments.request_date",$date)->whereBetween('appointments.status',[0,1])->get()->toArray();
		  			if(count($appointment_data)>0)
		  			{
		  				$record["waiting_time"] = $appointment_data[0]["waiting_time"];
		  			}
		  			/*$gett = DB::getQueryLog();
		  			print_r($gett);

		  			print_r($appointment_data);die;*/


		  			$data->error         = Common::error_false;
		        $data->errorMessage  = trans('messages.sucess');
		  			$data->record         = $record;
		  			$data->sub_cat_record         = $sub_cat_record;
		  			if(count($appointment_data)>0)
		  			{
		  				$data->book_status = 1;
		  				$data->request_status = $appointment_data[0]["status"];
		  				$data->appointment_id = $appointment_data[0]["id"];
		  				$data->admin_telephone = $appointment_data[0]["admin_telephone"];
		  			}else{
		  				$data->book_status = 0;
		  				$data->request_status = 0;
		  				$data->appointment_id = 0;
		  				$data->admin_telephone = 0;
		  			}
		     	}else{
		    		$data->error        = Common::error_true;
		        $data->errorMessage = trans('messages.no_record');
		    	}
		  	}catch(\Illuminate\Database\QueryException $ex){
		      $jsonresp=$ex->getMessage();
		      DB::rollBack();
		      $data->error   = $jsonresp;
		  	}
		    $response = $data;	
  	}
  	DB::commit();
  	
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function editHospitalProfile(Request $request)
	{
		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();
		if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
    		$response = new Response();
		    $hospital_id = $request->hospital_id;
		    if($request->category == 2)
				{
					$rules      = [
	    				'hospital_id' => 'required',
	    				'fullname' => 'required|min:2',
	    				'finess_number' => 'required|min:2',
	    				//'category' => 'required',
	    				#'sub_cat.*' => 'required',
	    				'admin_name' => 'required',
	            'admin_email'=> 'required|email|unique:hospitalusers,admin_email,'.$hospital_id,
	            'admin_telephone'=> 'required|max:15|min:7|unique:hospitalusers,admin_telephone,'.$hospital_id,
	           
	            'address'    => 'required',
	            'waiting_time'    => 'required|numeric',
		        ];
				}else{
		    	$rules      = [
	    				'hospital_id' => 'required',
	    				'fullname' => 'required|min:2',
	    				'finess_number' => 'required|min:2',
	    				//'category' => 'required',
	    				//"sub_cat"    => "required|array",
	    				#'sub_cat.*' => 'required',
	    				'admin_name' => 'required',
	            'admin_email'=> 'required|email|unique:hospitalusers,admin_email,'.$hospital_id,
	            'admin_telephone'=> 'required|max:15|min:7|unique:hospitalusers,admin_telephone,'.$hospital_id,
	            
	            'address'    => 'required',
	            'waiting_time'    => 'required|numeric',
		        ];
				}
		    $validator  = Validator::make($request->all(), $rules);
		    if ($validator->fails())
		    {
		        $data                   = $validator->messages();
		        $response->error        = Common::error_true;
		        $response->errorMessage = $data->first();
		    }else{
		    	$data   = new DataService();
			  	try{
			  			#echo "hello";die;
			  			$latitude = $request->latitude;	
	        		$longitude = $request->longitude;
	        		if($latitude == '' || $longitude == '')
	        		{
	        			$data->error        = Common::error_true;
			          $data->errorMessage = trans('messages.google_address_error');
	        		}else{
	        			/*print_r($request->all());
	        			print_r($_FILES);
	        			die;*/

	        			if(!empty($_FILES["image"]["name"]))
                    {
                    	/*print_r($_FILES);
                    	echo "string";die;*/
                        $image = $request->file('image');
                        //echo "<pre>";print_r($image);
                        $random = substr(md5(mt_rand()), 0, 4);
                        $file_name = $input['imagename'] = time().$random.'specialist'.'.'.$image->getClientOriginalExtension();
                        $destinationPath = public_path('/upload/usersprofile');
                        $image->move($destinationPath, $input['imagename']);
                        //echo $input['imagename']."form submit";

                        if(!empty($request->old_image))
                        {
                            $old_image = $request->old_image;
                            $destinationPath = public_path('/upload/usersprofile');
                            $file_pointer = $destinationPath.'/'.$old_image;
                            if (file_exists($file_pointer))
                            {
                                unlink($destinationPath.'/'.$old_image);
                            }

                        }
                    }else{
                        if(!empty($request->old_image))
                        {
                            $file_name = $request->old_image;
                        }else{
                            $file_name = "";
                        }
                    }


	        			$array_data = array(
	        					"fullname" => $request->fullname,
	        					"company_name" => $request->company_name,
	        					"finess_number" => $request->finess_number,
	        					//"category" => $request->category,
	        					"admin_name" => $request->admin_name,
	        					"admin_email" => $request->admin_email,
	        					"admin_telephone" => $request->admin_telephone,
	        					"speciality_detail" => $request->speciality_detail,
	        					"opening_hour" => $request->opening_hour,
	        					"address" => $request->address,
	        					"latitude" => $request->latitude,
	        					"longitude" => $request->longitude,
	        					"waiting_time" => $request->waiting_time,
	        					"status" => 1,
	        					"is_admin" => 0,
	        					"image" => $file_name,
	        			);
	        			#echo "hello else";die;
	        			#DB::table('hospitalusers')->insert($array_data);die;
	        			$Hospitaluser_obj = new Hospitaluser();
	        			#$hospital_record = $Hospitaluser_obj->select("category")->where("id",$hospital_id)->first();
	        			$response = $Hospitaluser_obj->where("id",$hospital_id)->update($array_data);
	        			//$Hospitaluser_obj->save();
	        			#echo $last_id;
	        			/*$gett = DB::getQueryLog();
	        			print_r($gett);die;*/
	        			#print_r($hospital_record);
	        			if ($response == 1)
			        	{
			        		#echo "if";die;
			        		/*$sub_cat = $request->sub_cat;
			        		$arr = array();
		        			for($x=0; $x<count($sub_cat); $x++)
		        			{
		        				$arr[] = $sub_cat[$x]["id"];
		        				$sub_cat_id = $sub_cat[$x]["id"];
			        			$array_data_second = array(
			        					"hospital_id" => $hospital_id,
			        					"sub_cat_id" => $sub_cat_id,
			        			);
			        			$Hospitalcategory_obj = new Hospitalcategory();
			        			$edit_count_record = $Hospitalcategory_obj->where("hospital_id",$hospital_id)->where("sub_cat_id",$sub_cat_id)->count();
			        			if($edit_count_record == 0)
			        			{
			        				$Hospitalcategory_obj = new Hospitalcategory($array_data_second);
			        				$Hospitalcategory_obj->save();
			        			}
		        			}
		        			$Hospitalcategory_obj = new Hospitalcategory();
		        			$hospital_cat_record = $Hospitalcategory_obj->where("hospital_id",$hospital_id)->get()->toArray();
		        			foreach ($hospital_cat_record as $key => $value)
		        			{
		        					if(!in_array($value["sub_cat_id"],$arr))
		        					{
		        						$Hospitalcategory_obj->where("hospital_id",$hospital_id)->where("sub_cat_id",$value["sub_cat_id"])->delete();
		        					}
		        			}*/
		        			/*print_r($arr);
			        			die;*/
			        		$record = $Hospitaluser_obj->where("id",$hospital_id)->get()->toArray();
			        		$record[0]["full_image"] = url('public/upload/usersprofile').'/'.$record[0]["image"];
			        		$data->error         = Common::error_false;
			            $data->errorMessage  = trans('messages.sucess');
			            $data->record  = $record[0];
			         	}else{
			        		$data->error        = Common::error_true;
			            $data->errorMessage = trans('messages.query');
			        	}

	        		}
			  		}catch(QueryException $ex){
			      $jsonresp=$ex->getMessage();
			      DB::rollBack();
			      $data->error   = $jsonresp;
			  	}
			    $response = $data;	
	  	}
    }
    $responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function editHospitalCategories(Request $request)
	{

		
		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();
		if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
    		$response = new Response();
		    $hospital_id = $request->hospital_id;
		    if($request->category == 2)
				{
					$rules      = [
	    				'hospital_id' => 'required',
	    				
	    				'category' => 'required'
	    				
		        ];
				}else{
		    	$rules      = [
	    				'hospital_id' => 'required',
	    				'category' => 'required',
	    				"sub_cat"    => "required|array"
		        ];
				}
		    $validator  = Validator::make($request->all(), $rules);
		    if ($validator->fails())
		    {
		        $data                   = $validator->messages();
		        $response->error        = Common::error_true;
		        $response->errorMessage = $data->first();
		    }else{
		    	$data   = new DataService();
			  	try{
			  			#echo "hello";die;
			  			 
	        			/*print_r($request->all());
	        			print_r($_FILES);
	        			die;*/

	        			


	        			$array_data = array(
	        					
	        					"category" => $request->category
	        			);
	        			#echo "hello else";die;
	        			#DB::table('hospitalusers')->insert($array_data);die;
	        			$Hospitaluser_obj = new Hospitaluser();
	        			#$hospital_record = $Hospitaluser_obj->select("category")->where("id",$hospital_id)->first();
	        			$response = $Hospitaluser_obj->where("id",$hospital_id)->update($array_data);
	        			//$Hospitaluser_obj->save();
	        			#echo $last_id;
	        			/*$gett = DB::getQueryLog();
	        			print_r($gett);die;*/
	        			#print_r($hospital_record);
	        			if ($response == 1)
			        	{
			        		#echo "if";die;
			        		$sub_cat = $request->sub_cat;
			        		$arr = array();
		        			for($x=0; $x<count($sub_cat); $x++)
		        			{
		        				$arr[] = $sub_cat[$x]["id"];
		        				$sub_cat_id = $sub_cat[$x]["id"];
			        			$array_data_second = array(
			        					"hospital_id" => $hospital_id,
			        					"sub_cat_id" => $sub_cat_id,
			        			);
			        			$Hospitalcategory_obj = new Hospitalcategory();
			        			$edit_count_record = $Hospitalcategory_obj->where("hospital_id",$hospital_id)->where("sub_cat_id",$sub_cat_id)->count();
			        			if($edit_count_record == 0)
			        			{
			        				$Hospitalcategory_obj = new Hospitalcategory($array_data_second);
			        				$Hospitalcategory_obj->save();
			        			}
		        			}
		        			$Hospitalcategory_obj = new Hospitalcategory();
		        			$hospital_cat_record = $Hospitalcategory_obj->where("hospital_id",$hospital_id)->get()->toArray();
		        			foreach ($hospital_cat_record as $key => $value)
		        			{
		        					if(!in_array($value["sub_cat_id"],$arr))
		        					{
		        						$Hospitalcategory_obj->where("hospital_id",$hospital_id)->where("sub_cat_id",$value["sub_cat_id"])->delete();
		        					}
		        			}
		        			if($request->category == 2)
		        			{
		        				$Hospitalcategory_obj = new Hospitalcategory();
		        				$Hospitalcategory_obj->where("hospital_id",$hospital_id)->delete();
		        			}
		        			/*print_r($arr);
			        			die;*/
			        		$record = $Hospitaluser_obj->where("id",$hospital_id)->get()->toArray();
			        		$record[0]["full_image"] = url('public/upload/usersprofile').'/'.$record[0]["image"];
			        		$data->error         = Common::error_false;
			            $data->errorMessage  = trans('messages.sucess');
			            $data->record  = $record[0];
			         	}else{
			        		$data->error        = Common::error_true;
			            $data->errorMessage = trans('messages.query');
			        	}

	        		
			  		}catch(QueryException $ex){
			      $jsonresp=$ex->getMessage();
			      DB::rollBack();
			      $data->error   = $jsonresp;
			  	}
			    $response = $data;	
	  	}
    }
    $responsedata = Defaults::encode($response);
	  return $responsedata;
	
	
	}
	public function getEmergencyContact(Request $request)
	{
		$Settings_obj = new Settings;
		$response   = new Response();

			$data   = new DataService();
	  	try{
	  			$record = $Settings_obj->where("attribute_key","emergency_no")->get()->toArray();
			  		if(count($record)>0)
			  		{
			  			$data->error         = Common::error_false;
			        $data->errorMessage  = trans('messages.sucess');
			  			$data->record         = $record[0];
				    }else{
			    		$data->error        = Common::error_true;
			        $data->errorMessage = trans('messages.no_record');
			    	}
  			}catch(QueryException $ex){
		      $jsonresp=$ex->getMessage();
		      DB::rollBack();
		      $data->error   = $jsonresp;
		  	}
  			$response = $data;
  		
  	DB::commit();
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function getAdminContact(Request $request)
	{
		$Admincontacts_obj = new Admincontacts;
		$response   = new Response();

			$data   = new DataService();
	  	try{
	  			$record = $Admincontacts_obj->where("id",1)->get()->toArray();
			  		if(count($record)>0)
			  		{
			  			$data->error         = Common::error_false;
			        $data->errorMessage  = trans('messages.sucess');
			  			$data->record         = $record[0];
				    }else{
			    		$data->error        = Common::error_true;
			        $data->errorMessage = trans('messages.no_record');
			    	}
  			}catch(QueryException $ex){
		      $jsonresp=$ex->getMessage();
		      DB::rollBack();
		      $data->error   = $jsonresp;
		  	}
  			$response = $data;
  		
  	DB::commit();
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function getfaqs(Request $request)
	{
		$Faqs_obj = new Faqs;
		$response   = new Response();

			$data   = new DataService();
	  	try{
	  			$record = $Faqs_obj->get()->toArray();
			  		if(count($record)>0)
			  		{
			  			$data->error         = Common::error_false;
			        $data->errorMessage  = trans('messages.sucess');
			  			$data->record         = $record;
				    }else{
			    		$data->error        = Common::error_true;
			        $data->errorMessage = trans('messages.no_record');
			    	}
  			}catch(QueryException $ex){
		      $jsonresp=$ex->getMessage();
		      DB::rollBack();
		      $data->error   = $jsonresp;
		  	}
  			$response = $data;
  		
  	DB::commit();
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function hospitalForgotPassword(Request $request)
	{
		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();

		$rules = [
    				'email' => 'required|email'
          ];
    	$validator  = Validator::make($request->all(), $rules);
    	if ($validator->fails()){ 
    		#print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
    	}else{
				$data   = new DataService();
		  	try{
		  		$email = $request->email;
		  			$record = $Hospitaluser_obj->select("id","fullname","admin_email")->where("admin_email",$email)->get()->toArray();
				  		if(count($record)>0)
				  		{
				  			$new_password = mt_rand(100000, 999999);
                $new_password_md = md5($new_password);
                $Hospitaluser_obj->where("admin_email",$email)->update(["password"=>$new_password_md]);

                /* Send password on mail at registered mail id*/
               /*$objDemo = new \stdClass();
               $objDemo->sender = 'DoctUrgences';
               $objDemo->invoice_file = '';
               $objDemo->receiver = $record[0]["fullname"];
               $objDemo->password = $new_password;
               $objDemo->from = env( 'MAIL_USERNAME' );
               $objDemo->subject = trans('messages.Welcome to DoctUrgences');
               $objDemo->message = "translated message here";
               $objDemo->view_file = 'emailtemplate.user_forget_password';
               Mail::to($request->email)->send(new DemoEmail($objDemo)); */
                /**************/
                
				  			$data->error         = Common::error_false;
				        $data->errorMessage  = trans('messages.sucess');
				  			#$data->record         = $record[0];
					    }else{
				    		$data->error        = Common::error_true;
				        $data->errorMessage = trans('messages.no_record');
				    	}
	  			}catch(QueryException $ex){
			      $jsonresp=$ex->getMessage();
			      DB::rollBack();
			      $data->error   = $jsonresp;
			  	}
	  			$response = $data;
	  		}
  	DB::commit();
  	$responsedata = Defaults::encode($response);
	  return $responsedata;
	}
	public function specialistAppointmentchat(Request $request)
  {

      $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $rules   = [
              'appointment_id'   => 'required|numeric',
              'user_id'   => 'required|numeric',
              'hospital_id'=>'required|numeric',
              'message'=>'required'
          ];
          $validator  = Validator::make($request->all(), $rules);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          }else{
              $data   = new DataService();
              try{
              	#echo "hello";die;
                      $appointment_id = $request->appointment_id;
                      $Appointments_obj = new Appointments();
                      $appointment_record = $Appointments_obj->select("status")->where("id",$appointment_id)->first();
                      #print_r($appointment_record);die;
                      if($appointment_record)
                      {
                          $status = $appointment_record["status"];
                          /*if($status == 0)
                          {
                              //hold
                              $data->error         = Common::error_true;
                              $data->errorMessage  = trans('messages.specialist_appointment_hold');
                          }else*/ if($status == 2)
                          {
                              //reject
                              $data->error         = Common::error_true;
                              $data->errorMessage  = trans('messages.specialist_appointment_reject');
                          }else if($status == 3)
                          {
                              //completed
                              $data->error         = Common::error_true;
                              $data->errorMessage  = trans('messages.specialist_appointment_completed');
                          }else if($status == 1 || $status == 0){
                              $insert_data = array(
                                  "appointment_id"=>$request->appointment_id,
                                  "reciver_id"=>$request->user_id,
                                  "sender_id"=>$request->hospital_id,
                                  "message"=>$request->message,
                                  "status"=>0,
                                  "message_by"=>2,
                              );
                              $Appointmentchat_obj = new Appointmentchat($insert_data);
                              $response = $Appointmentchat_obj->save();
                              if($response == 1)
                              {
                                  $data->error = Common::error_false;
                                  $data->errorMessage = trans('messages.sucess');
                              }else{
                                  $data->error         = Common::error_true;
                                  $data->errorMessage  = trans('messages.query');
                              }
                          }else{
                              $data->error         = Common::error_true;
                              $data->errorMessage  = trans('messages.query');
                          }
                      }else{
                          //no appointments
                          $data->error         = Common::error_true;
                          $data->errorMessage  = trans('messages.no_appointment_available');
                      }                        
                  }catch(QueryException $ex){
                  $jsonresp=$ex->getMessage();
                  DB::rollBack();
                  $data->error   = false;
              }
              $response = $data;
          }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
  public function getSpecialistPandingRequest(Request $request)
  {
      $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $rules   = [
              'hospital_id'=>'required|numeric'
          ];
          $validator  = Validator::make($request->all(), $rules);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          } else {
              $hospital_id = $request->hospital_id;
              $data   = new DataService();
              try{
                      
                      $Appointments_obj = new Appointments();
                      $response = $Appointments_obj->select("appointments.id","appointments.hospital_id","appointments.user_id","appointments.request_date","appointments.request_time","appointments.message","appointments.status","hospitalusers.fullname","hospitalusers.finess_number","hospitalusers.company_name","hospitalusers.admin_name","hospitalusers.admin_email","hospitalusers.admin_telephone","hospitalusers.address","hospitalusers.waiting_time","users.fullname as user_fullname","users.email","users.telephone","users.gender","users.height","users.weight","users.allergy","users.blood_group","users.in_charge_doctor","users.family","users.dmp","users.medical_history","users.image","users.current_lat","users.current_long","users.current_address")
                      ->join("hospitalusers","appointments.hospital_id","hospitalusers.id")
                      ->join("users","appointments.user_id","users.id")
                      ->where("appointments.status","0")
                      ->where("appointments.hospital_id",$hospital_id)
                      ->get()->toArray();
                      #print_r($response);die;
                      if(count($response)>0)
                      {
                      	$x=0;
                      	foreach ($response as $key => $value)
                      	{
                      		$response[$x]["full_image"] = url('/public/upload/usersprofile').'/'.$value["image"];
                      		$x++;
                      	}
                          $data->error = Common::error_false;
                          $data->errorMessage = trans('messages.sucess');
                          $data->record = $response;
                      }else{
                          $data->error         = Common::error_true;
                          $data->errorMessage  = trans('messages.no_record');
                      }
                  }catch(QueryException $ex){
                  $jsonresp=$ex->getMessage();
                  DB::rollBack();
                  $data->error   = false;
              }
              
              $response = $data;
          }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
  public function getSpecialistApproveRequest(Request $request)
  {
      $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $rules   = [
              'hospital_id'=>'required|numeric'
          ];
          $validator  = Validator::make($request->all(), $rules);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          } else {
              $hospital_id = $request->hospital_id;
              $data   = new DataService();
              try{
                      
                      $Appointments_obj = new Appointments();
                      $response = $Appointments_obj->select("appointments.id","appointments.hospital_id","appointments.user_id","appointments.request_date","appointments.request_time","appointments.message","appointments.status","hospitalusers.fullname","hospitalusers.finess_number","hospitalusers.company_name","hospitalusers.admin_name","hospitalusers.admin_email","hospitalusers.admin_telephone","hospitalusers.address","hospitalusers.waiting_time","users.fullname as user_fullname","users.email","users.telephone","users.gender","users.height","users.weight","users.allergy","users.blood_group","users.in_charge_doctor","users.family","users.dmp","users.medical_history","users.image","users.current_lat","users.current_long","users.current_address")
                      ->join("hospitalusers","appointments.hospital_id","hospitalusers.id")
                      ->join("users","appointments.user_id","users.id")
                      ->where("appointments.status","1")
                      ->where("appointments.hospital_id",$hospital_id)
                      ->get()->toArray();
                      #print_r($response);die;
                      if(count($response)>0)
                      {
	                      	$x=0;
	                      	foreach ($response as $key => $value)
	                      	{
	                      		$response[$x]["full_image"] = url('/public/upload/usersprofile').'/'.$value["image"];
	                      		$x++;
	                      	}
                          $data->error = Common::error_false;
                          $data->errorMessage = trans('messages.sucess');
                          $data->record = $response;
                      }else{
                          $data->error         = Common::error_true;
                          $data->errorMessage  = trans('messages.no_record');
                      }
                  }catch(QueryException $ex){
                  $jsonresp=$ex->getMessage();
                  DB::rollBack();
                  $data->error   = false;
              }
              
              $response = $data;
          }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
  public function getSpecialistRejectRequest(Request $request)
  {
      $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $rules   = [
              'hospital_id'=>'required|numeric'
          ];
          $validator  = Validator::make($request->all(), $rules);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          } else {
              $hospital_id = $request->hospital_id;
              $data   = new DataService();
              try{
                      
                      $Appointments_obj = new Appointments();
                      $response = $Appointments_obj->select("appointments.id","appointments.hospital_id","appointments.user_id","appointments.request_date","appointments.request_time","appointments.message","appointments.status","hospitalusers.fullname","hospitalusers.finess_number","hospitalusers.company_name","hospitalusers.admin_name","hospitalusers.admin_email","hospitalusers.admin_telephone","hospitalusers.address","hospitalusers.waiting_time","users.fullname as user_fullname","users.email","users.telephone","users.gender","users.current_lat","users.current_long","users.current_address")
                      ->join("hospitalusers","appointments.hospital_id","hospitalusers.id")
                      ->join("users","appointments.user_id","users.id")
                      ->where("appointments.status","2")
                      ->where("appointments.hospital_id",$hospital_id)
                      ->get()->toArray();
                      #print_r($response);die;
                      if(count($response)>0)
                      {
                      		$x=0;
	                      	foreach ($response as $key => $value)
	                      	{
	                      		$response[$x]["full_image"] = url('/public/upload/usersprofile').'/'.$value["image"];
	                      		$x++;
	                      	}
                          $data->error = Common::error_false;
                          $data->errorMessage = trans('messages.sucess');
                          $data->record = $response;
                      }else{
                          $data->error         = Common::error_true;
                          $data->errorMessage  = trans('messages.no_record');
                      }
                  }catch(QueryException $ex){
                  $jsonresp=$ex->getMessage();
                  DB::rollBack();
                  $data->error   = false;
              }
              
              $response = $data;
          }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
  public function getSpecialistCompleteRequest(Request $request)
  {
      $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $rules   = [
              'hospital_id'=>'required|numeric'
          ];
          $validator  = Validator::make($request->all(), $rules);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          } else {
              $hospital_id = $request->hospital_id;
              $data   = new DataService();
              try{
                      
                      $Appointments_obj = new Appointments();
                      $response = $Appointments_obj->select("appointments.id","appointments.hospital_id","appointments.user_id","appointments.request_date","appointments.request_time","appointments.message","appointments.status","hospitalusers.fullname","hospitalusers.finess_number","hospitalusers.company_name","hospitalusers.admin_name","hospitalusers.admin_email","hospitalusers.admin_telephone","hospitalusers.address","hospitalusers.waiting_time","users.fullname as user_fullname","users.email","users.telephone","users.gender","users.height","users.weight","users.allergy","users.blood_group","users.in_charge_doctor","users.family","users.dmp","users.medical_history","users.image","users.current_lat","users.current_long","users.current_address")
                      ->join("hospitalusers","appointments.hospital_id","hospitalusers.id")
                      ->join("users","appointments.user_id","users.id")
                      ->where("appointments.status","3")
                      ->where("appointments.hospital_id",$hospital_id)
                      ->get()->toArray();
                      #print_r($response);die;
                      if(count($response)>0)
                      {
                      		$x=0;
	                      	foreach ($response as $key => $value)
	                      	{
	                      		$response[$x]["full_image"] = url('/public/upload/usersprofile').'/'.$value["image"];
	                      		$x++;
	                      	}
                          $data->error = Common::error_false;
                          $data->errorMessage = trans('messages.sucess');
                          $data->record = $response;
                      }else{
                          $data->error         = Common::error_true;
                          $data->errorMessage  = trans('messages.no_record');
                      }
                  }catch(QueryException $ex){
                  $jsonresp=$ex->getMessage();
                  DB::rollBack();
                  $data->error   = false;
              }
              
              $response = $data;
          }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
  public function updateAppointmentStatus(Request $request)
  {

		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();
		if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
    		$response = new Response();
					$rules      = [
	    				'id' => 'required|numeric',
	    				'status' => 'required|numeric'
		        ];
		    $validator  = Validator::make($request->all(), $rules);
		    if ($validator->fails())
		    {
		        $data                   = $validator->messages();
		        $response->error        = Common::error_true;
		        $response->errorMessage = $data->first();
		    }else{
		    	$data   = new DataService();
		  	try{
        			#print_r($request->all());

		  				$id = $request->id;
        			$array_data = array(
        					"status" => $request->status
        			);
        			$Appointments_obj = new Appointments();
        			$response = $Appointments_obj->where("id",$id)->update($array_data);
        			if ($response == 1)
		        	{
		        		
		        		$data->error         = Common::error_false;
		            $data->errorMessage  = trans('messages.sucess');
		         	}else{
		        		$data->error        = Common::error_true;
		            $data->errorMessage = trans('messages.query');
		        	}
			  		}catch(QueryException $ex){
			      $jsonresp=$ex->getMessage();
			      DB::rollBack();
			      $data->error   = $jsonresp;
			  	}
			    $response = $data;	
	  	}
    }
    $responsedata = Defaults::encode($response);
	  return $responsedata;
  }
  public function getAppointmentDetailSingle(Request $request)
  {
		$response = new Response();
    if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
        $rules   = [
            'appointment_id'=>'required|numeric'
        ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
        } else {
            $appointment_id = $request->appointment_id;
            $data   = new DataService();
            try{
                    
                    $Appointments_obj = new Appointments();
                    $response = $Appointments_obj->select("appointments.id","appointments.hospital_id","appointments.user_id","appointments.request_date","appointments.request_time","appointments.message","appointments.status","hospitalusers.fullname","hospitalusers.finess_number","hospitalusers.company_name","hospitalusers.admin_name","hospitalusers.admin_email","hospitalusers.admin_telephone","hospitalusers.address","appointments.waiting_time","users.fullname as user_fullname","users.email","users.telephone","users.gender","users.height","users.weight","users.allergy","users.blood_group","users.in_charge_doctor","users.family","users.dmp","users.medical_history","users.image","users.current_lat","users.current_long","users.current_address")
                    ->join("hospitalusers","appointments.hospital_id","hospitalusers.id")
                    ->join("users","appointments.user_id","users.id")
                    ->where("appointments.id",$appointment_id)
                    ->get()->toArray();
                    #print_r($response);die;
                    if(count($response)>0)
                    {
                    		$x=0;
                      	foreach ($response as $key => $value)
                      	{
                      		$response[$x]["full_image"] = url('/public/upload/usersprofile').'/'.$value["image"];
                      		$x++;
                      	}
                        $data->error = Common::error_false;
                        $data->errorMessage = trans('messages.sucess');
                        $data->record = $response;
                    }else{
                        $data->error         = Common::error_true;
                        $data->errorMessage  = trans('messages.no_record');
                    }
                }catch(QueryException $ex){
                $jsonresp=$ex->getMessage();
                DB::rollBack();
                $data->error   = false;
            }
            
            $response = $data;
        }
    }
    $responsedata = Defaults::encode($response);
    return $responsedata;
  }
  public function updateAppointmentWatingTime(Request $request)
  {

		$Hospitaluser_obj = new Hospitaluser;
		$response   = new Response();
		if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
    		$response = new Response();
					$rules      = [
	    				'appointment_id' => 'required|numeric',
	    				'waiting_time' => 'required|numeric'
		        ];
		    $validator  = Validator::make($request->all(), $rules);
		    if ($validator->fails())
		    {
		        $data                   = $validator->messages();
		        $response->error        = Common::error_true;
		        $response->errorMessage = $data->first();
		    }else{
		    	$data   = new DataService();
		  	try{
        			#print_r($request->all());

		  				$appointment_id = $request->appointment_id;
        			$array_data = array(
        					"waiting_time" => $request->waiting_time
        			);
        			$Appointments_obj = new Appointments();
        			$response = $Appointments_obj->where("id",$appointment_id)->update($array_data);
        			if ($response == 1)
		        	{
		        		
		        		$data->error         = Common::error_false;
		            $data->errorMessage  = trans('messages.sucess');
		         	}else{
		        		$data->error        = Common::error_true;
		            $data->errorMessage = trans('messages.query');
		        	}
			  		}catch(QueryException $ex){
			      $jsonresp=$ex->getMessage();
			      DB::rollBack();
			      $data->error   = $jsonresp;
			  	}
			    $response = $data;	
	  	}
    }
    $responsedata = Defaults::encode($response);
	  return $responsedata;
  }
  public function getUserDetail(Request $request)
  {
    $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $messages = ['user_id.required' => trans('validation.required'),
                'user_id.numeric' => trans('validation.numeric')];

          $rules   = ['user_id'   => 'required|numeric'];
          $validator  = Validator::make($request->all(), $rules,$messages);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          } else {
              $userId = $request->user_id;
              $isExist = Users::select('*')->where('id',$userId)->first();
              $data   = new DataService();
              if($isExist)
              {
                  $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
                  $isExist["old_image"] = $isExist["image"];
                  if($isExist["gender"] == "M")
                  {
                      $isExist["gender"] = trans('messages.Male');
                  }else if($isExist["gender"] == "F")
                  {
                      $isExist["gender"] = trans('messages.Female');
                  }
                  $data->error = Common::error_false;
                  $data->errorMessage = trans('messages.sucess');
                  $data->usersDetails  = $isExist;
                  #$data->usersDetails['profile_pic_url'] = url('public/upload/usersprofile/');
              }else{
                  $data->error         = Common::error_true;
                  $data->errorMessage  = trans('messages.invalidUser');
              }
              $response = $data;
          }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
  public function getUserPermission(Request $request)
  {
    $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $messages = ['user_id.required' => trans('validation.required'),
                'user_id.numeric' => trans('validation.numeric')];

          $rules   = ['user_id'   => 'required|numeric'];
          $validator  = Validator::make($request->all(), $rules,$messages);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          } else {
              $userId = $request->user_id;
              $Hospitaluser_obj = new Hospitaluser;
              $isExist = $Hospitaluser_obj->select('allow_visibility','allow_notification','allow_call','allow_chat')->where('id',$userId)->first();
              $data   = new DataService();
              if($isExist)
              {
                  
                  $data->error = Common::error_false;
                  $data->errorMessage = trans('messages.sucess');
                  $data->usersDetails  = $isExist;
                  #$data->usersDetails['profile_pic_url'] = url('public/upload/usersprofile/');
              }else{
                  $data->error         = Common::error_true;
                  $data->errorMessage  = trans('messages.invalidUser');
              }
              $response = $data;
          }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
  public function updateAllowPermission(Request $request)
  {
    $response = new Response();
      if(!$request->token_check){
          $response->error        = Common::error_true;
          $response->errorMessage = trans('messages.token_mismatch');
      }else{
          $messages = ['user_id.required' => trans('validation.required'),
                'user_id.numeric' => trans('validation.numeric')];

          $rules   = [
          	'user_id'   => 'required|numeric',
          	'allow_visibility'   => 'required|numeric',
          	'allow_notification'   => 'required|numeric',
          	'allow_call'   => 'required|numeric',
          	'allow_chat'   => 'required|numeric',
          ];
          $validator  = Validator::make($request->all(), $rules,$messages);
          if ($validator->fails()) {
           $data                   = $validator->messages();
           $response->error        = Common::error_true;
           $response->errorMessage = $data->first();
          } else {
          		$data   = new DataService();
					  	try{
			        			#print_r($request->all());

					  					 $userId = $request->user_id;
				              $Hospitaluser_obj = new Hospitaluser();
				              $array_data = array(
				              		"allow_visibility" => $request->allow_visibility,
				              		"allow_notification" => $request->allow_notification,
				              		"allow_call" => $request->allow_call,
				              		"allow_chat" => $request->allow_chat,
				              );
				              $response_k = $Hospitaluser_obj->where("id",$userId)->update($array_data);
				              if ($response_k == 1)
						        	{
						        		
						        		$data->error         = Common::error_false;
						            $data->errorMessage  = trans('messages.sucess');
						         	}else{
						        		$data->error        = Common::error_true;
						            $data->errorMessage = trans('messages.query');
						        	}
						  		}catch(QueryException $ex){
						      $jsonresp=$ex->getMessage();
						      DB::rollBack();
						      $data->error   = $jsonresp;
						  	}
						    $response = $data;	
			      }
      }
      $responsedata = Defaults::encode($response);
      return $responsedata;
  }
}

