<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::view('login',"admin.login",[ "heading" => trans('messages.Admin Login') ]);
Route::view('admin',"admin.login",[ "heading" => trans('messages.Admin Login') ]);
Route::post('admin/LoginSubmit', "admin\AdminController@LoginSubmit");


Route::prefix("admin")->group(function(){
	Route::middleware(["AdminCheck"])->group(function(){
		Route::get('dashboard',"admin\AdminController@dashboard");
		Route::get("cudhuegdnbav/{id}/{status}/{callback}/{table}","admin\AdminController@CommonAed");


Route::get("listCategory",function(){
			$data["heading"] = trans("messages.List Category");
			$Category_obj = new Category();
			$data["all_category"] = $Category_obj->all_category();
			return view("admin.listCategory")->with(array("data"=>$data));
		});
Route::get("addCategory",function(){
			$data["heading"] = trans("messages.addCategory");
			return view("admin.addCategory")->with(array("data"=>$data));
		});
		Route::get("editCategory/{id}",function($id){
			$data["heading"] = trans("messages.Edit Category");
			$Category_obj = new Category();
			$id = Crypt::decryptString($id);
			$where = array("id"=>$id);
			$data["record"] = $Category_obj->category_where_clause($where);
			return view("admin.editCategory")->with(array("data"=>$data));
		});
		Route::post("editCatSubmit","admin\AdminController@editCatSubmit");
		Route::get("addSubCategory",function(){
			$data["heading"] = trans("messages.addSubCategory");
			return view("admin.addSubCategory")->with(array("data"=>$data));
		});
		Route::post("addSubCatSubmit","admin\AdminController@addSubCatSubmit");
		
		Route::get("listSubCategory",function(){
			$data["heading"] = trans("messages.listSubCategory");
			$Sub_cat_obj = new Sub_cat();
			$data["record"] = $Sub_cat_obj->all_record();
			return view("admin.listSubCategory")->with(array("data"=>$data));
		});
		Route::get("editSubCategory/{id}",function($id){
			$data["heading"] = trans("messages.Edit Sub Category");
			$id = Crypt::decryptString($id);
			$where = array("id"=>$id);
			$Sub_cat_obj = new Sub_cat();
			$data["record"] = $Sub_cat_obj->get_where_clause($where);
			return view("admin.editSubCategory")->with(array("data"=>$data));
		});
		Route::post("editSubCatSubmit","admin\AdminController@editSubCatSubmit");

		});
});